#include "configulator.h"
#ifdef ESP_PLATFORM
#include "nvs_flash.h"
#include "esp_log.h"

#define TAG "CFGLR"

void cfglr_backend_nvs_open(cfglr_backend_t *backend, cfglr_handle_t *handle) {
  ESP_LOGI(TAG, "opening NVS partition: %s", handle->namespace);
  esp_err_t err = nvs_open(handle->namespace, NVS_READWRITE, &backend->nvs_handle);
}

void cfglr_backend_nvs_close(cfglr_backend_t *backend, cfglr_handle_t *handle) {
}
#endif

uint8_t cfglr_init(cfglr_handle_t *handle) {
  uint8_t tick = 0;
  cfglr_backend_t *backend;
  cfglr_element_t *element;

  while((backend = &handle->backends[tick])) {
    if(backend->open == NULL) break;

    backend->open(backend, handle);

    ++tick;
  }

  tick = 0;

  while((element = &handle->elements[tick])) {
    if(element->key == NULL) break;

    // all elements should start out dirty, =
    // they should be fetched, or defaulted
    if(element->dirty) {
      backend->get(backend, element, handle);
    }
  }
  return 0;
}
